// $Id: DOMBuilder.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMBuilder_H__
#define __DOMBuilder_H__

#import <Foundation/NSObject.h>
#include <DOM/DOMDocument.h>

/*
  A protocol which defines the behaviour of DOM builders (classes
  which build DOM trees from some kind of resource).
*/

@protocol DOMBuilder

/* parsing */

- (id<NSObject,DOMDocument>)buildFromSource:(id)_source;
- (id<NSObject,DOMDocument>)buildFromSource:(id)_source
  systemId:(NSString *)_sysId;
- (id<NSObject,DOMDocument>)buildFromSystemId:(NSString *)_sysId;

@end

#endif /* __DOMBuilder_H__ */
