// $Id: DOMBuilderFactory.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMBuilderFactory_H__
#define __DOMBuilderFactory_H__

#import <Foundation/NSObject.h>
#include <DOM/DOMBuilder.h>

/*
  To get a reader for HTML files:
    reader = [factory createDOMBuilderForMimeType:@"text/html"];

  for XML files:
    reader = [factory createDOMBuilderForMimeType:@"text/xml"];
    
  a specific reader:
    reader = [factory createDOMBuilderWithName:@"libxmlSAXDriver"];
*/

@class NSDictionary;
    
@interface DOMBuilderFactory : NSObject
{
}

+ (id)standardDOMBuilderFactory;

- (id<NSObject,DOMBuilder>)createDOMBuilder;
- (id<NSObject,DOMBuilder>)createDOMBuilderWithName:(NSString *)_name;
- (id<NSObject,DOMBuilder>)createDOMBuilderForMimeType:(NSString *)_mtype;

- (NSArray *)availableDOMBuilders;

@end

#endif /* __DOMBuilderFactory_H__ */
