// $Id: DOMDocument+factory.m,v 1.2 2003/01/02 09:51:24 helge Exp $

#include <DOM/DOMDocument.h>
#include <DOM/DOMProcessingInstruction.h>
#include <DOM/DOMElement.h>
#include <DOM/DOMAttribute.h>
#include <DOM/DOMEntityReference.h>
#include <DOM/DOMImplementation.h>
#include "common.h"

#include <DOM/DOMTreeWalker.h>

@implementation DOMDocument(DocumentTraversal)

- (Class)domTreeWalkerClass {
  return NSClassFromString(@"DOMTreeWalker");
}

- (id)createNodeIterator:(id)_node
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter
{
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}

- (id)createTreeWalker:(id)_rootNode
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter
  expandEntityReferences:(BOOL)_expandEntityReferences
{
  id walker;

  // should throw DOMException with NOT_SUPPORTED_ERR
  NSAssert(_rootNode, @"invalid root node !");

  walker = [[[self domTreeWalkerClass] alloc]
                   initWithRootNode:_rootNode
                   whatToShow:_whatToShow
                   filter:_filter
                   expandEntityReferences:_expandEntityReferences];
  return [walker autorelease];
}

@end /* DOMDocument(DocumentTraversal) */
