// $Id: DOMDocument.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMDocument_H__
#define __DOMDocument_H__

#include <DOM/DOMNode.h>

@class NSString, NSArray;
@class DOMImplementation;

@interface DOMDocument : DOMNodeWithChildren < DOMDocument >
{
  NSString          *qname;
  NSString          *uri;
  id                doctype;
  DOMImplementation *dom;
  
  NSArray           *errors;
  NSArray           *warnings;
}

+ (id)documentFromData:(NSData *)_data;
+ (id)documentFromString:(NSString *)_string;
+ (id)documentFromURI:(NSString *)_uri;

/* errors/warnings */

- (void)addErrors:(NSArray *)_errors;
- (void)addWarnings:(NSArray *)_errors;

@end

@interface DOMDocument(DocumentTraversal)

- (id)createNodeIterator:(id)_node
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter;

- (id)createTreeWalker:(id)_node
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter
  expandEntityReferences:(BOOL)_expandEntityReferences;

@end

@interface DOMDocument(PrivateCtors)

/* use DOMImplementation for constructing DOMDocument ! */

- (id)initWithName:(NSString *)_qname
  namespaceURI:(NSString *)_uri
  documentType:(id)_doctype
  dom:(DOMImplementation *)_dom;

@end

#endif /* __DOMDocument_H__ */
