// $Id: DOMEntity.m,v 1.2 2003/01/02 09:51:24 helge Exp $

#include "DOMEntity.h"
#include "common.h"

@implementation DOMEntity

/* attributes */

- (NSString *)publicId {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}
- (NSString *)systemId {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}
- (NSString *)notationName {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}

/* node */

- (DOMNodeType)nodeType {
  return DOM_ENTITY_NODE;
}

- (BOOL)_isValidChildNode:(id)_node {
  switch ([_node nodeType]) {
    case DOM_ELEMENT_NODE:
    case DOM_PROCESSING_INSTRUCTION_NODE:
    case DOM_COMMENT_NODE:
    case DOM_TEXT_NODE:
    case DOM_CDATA_SECTION_NODE:
    case DOM_ENTITY_REFERENCE_NODE:
      return YES;
        
    default:
      return NO;
  }
}

- (id)attributes {
  return nil;
}

/* parent node */

- (id)parentNode {
  return nil;
}
- (id)nextSibling {
  return nil;
}
- (id)previousSibling {
  return nil;
}

@end /* DOMEntity */
