// $Id: DOMEntityReference.m,v 1.2 2003/01/02 09:51:25 helge Exp $

#include "DOMEntityReference.h"
#include "common.h"

@implementation DOMEntityReference

- (id)initWithName:(NSString *)_name {
  self->name = [_name copy];
  return self;
}
- (void)dealloc {
  [self->name release];
  [super dealloc];
}

- (DOMNodeType)nodeType {
  return DOM_ENTITY_REFERENCE_NODE;
}

- (id)attributes {
  return nil;
}

/* parent node */

- (void)_domNodeRegisterParentNode:(id)_parent {
  self->parent = _parent;
}
- (void)_domNodeForgetParentNode:(id)_parent {
  if (_parent == self->parent)
    /* the node's parent was deallocated */
    self->parent = nil;
}
- (id)parentNode {
  return self->parent;
}

@end /* DOMEntityReference */
