// $Id: DOMImplementation.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMImplementation_H__
#define __DOMImplementation_H__

#import <Foundation/NSObject.h>

@class NSString;

@interface DOMImplementation : NSObject
{
  Class elementClass;
  Class textNodeClass;
  Class attrClass;
}

- (id)createDocumentWithName:(NSString *)_qname
  namespaceURI:(NSString *)_uri
  documentType:(id)_doctype;

- (id)createDocumentType:(NSString *)_qname
  publicId:(NSString *)_pubId
  systemId:(NSString *)_sysId;

@end

@interface DOMImplementation(PrivateClassRegistry)
- (Class)domElementClass;
- (Class)domElementNSClass;
- (Class)domDocumentFragmentClass;
- (Class)domTextNodeClass;
- (Class)domCommentClass;
- (Class)domCDATAClass;
- (Class)domProcessingInstructionClass;
- (Class)domAttributeClass;
- (Class)domAttributeNSClass;
- (Class)domEntityReferenceClass;
@end

#endif /* __DOMImplementation_H__ */
