// $Id: DOMImplementation.m,v 1.2 2003/01/02 09:51:25 helge Exp $

#include "DOMImplementation.h"
#include "DOMDocument.h"
#include "DOMDocumentFragment.h"
#include "common.h"

@implementation DOMImplementation

- (id)init {
  self->elementClass  = NSClassFromString(@"DOMElement");
  self->textNodeClass = NSClassFromString(@"DOMText");
  self->attrClass     = NSClassFromString(@"DOMAttribute");
  return self;
}

- (Class)domDocumentClass {
  return [DOMDocument class];
}
- (Class)domDocumentTypeClass {
  return NSClassFromString(@"DOMDocumentType");
}

- (Class)domElementClass {
  return self->elementClass;
}
- (Class)domElementNSClass {
  return self->elementClass;
}
- (Class)domDocumentFragmentClass {
  return NSClassFromString(@"DOMDocumentFragment");
}
- (Class)domTextNodeClass {
  return self->textNodeClass;
}
- (Class)domCommentClass {
  return NSClassFromString(@"DOMComment");
}
- (Class)domCDATAClass {
  return NSClassFromString(@"DOMCDATA");
}
- (Class)domProcessingInstructionClass {
  return NSClassFromString(@"DOMProcessingInstruction");
}
- (Class)domAttributeClass {
  return self->attrClass;
}
- (Class)domAttributeNSClass {
  return self->attrClass;
}
- (Class)domEntityReferenceClass {
  return NSClassFromString(@"DOMEntityReference");
}

- (id)createDocumentWithName:(NSString *)_qname
  namespaceURI:(NSString *)_uri
  documentType:(id)_doctype
{
  id doc;
  
  doc = [[[self domDocumentClass]
                alloc]
                initWithName:_qname
                namespaceURI:_uri
                documentType:_doctype
	        dom:self];
  
  return [doc autorelease];
}

- (id)createDocumentType:(NSString *)_qname
  publicId:(NSString *)_pubId
  systemId:(NSString *)_sysId
{
  id doc;
  
  doc = [[[self domDocumentTypeClass]
                alloc]
                initWithName:_qname
                publicId:_pubId
                systemId:_sysId
	        dom:self];
  
  return [doc autorelease];
}

@end /* DOMImplementation */
