// $Id: DOMNode+Enum.m,v 1.2 2003/01/02 09:51:25 helge Exp $

#include "DOMNode+Enum.h"
#include "common.h"

@interface _DOMNodeParentNodeEnumerator : NSEnumerator
{
  id currentNode;
}
+ (id)enumeratorWithDOMNode:(id)_node;
@end

@implementation NSObject(DOMNodeEnum)

- (NSEnumerator *)domParentNodeEnumerator {
  return [_DOMNodeParentNodeEnumerator enumeratorWithDOMNode:
                                         [(DOMNode *)self parentNode]];
}

@end /* DOMNode(Enum) */

@implementation DOMNode(Enum)

- (NSEnumerator *)parentNodeEnumerator {
  return [self domParentNodeEnumerator];
}

@end /* DOMNode(Enum) */

@implementation _DOMNodeParentNodeEnumerator

+ (id)enumeratorWithDOMNode:(id)_node {
  _DOMNodeParentNodeEnumerator *e;
  e = [self alloc];
  e->currentNode = [_node retain];
  return [e autorelease];
}

- (void)dealloc {
  [self->currentNode release];
  [super dealloc];
}

- (id)nextObject {
  id old;

  old = self->currentNode;
  self->currentNode = [[old parentNode] retain];
  return [old autorelease];
}

@end /* _DOMNodeParentNodeEnumerator */
