// $Id: DOMNode+QueryPath.m,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#include "DOMNode+QueryPath.h"
#include "DOMQueryPathExpression.h"
#include "common.h"

@implementation DOMNode(QueryPath)

- (id)lookupPathComponents:(NSArray *)_path {
  DOMQueryPathExpression *expr;
  
  if (_path == nil)
    return nil;
  
  expr = [DOMQueryPathExpression queryPathWithComponents:_path];
  
  return [expr evaluateWithNode:self];
}

- (id)lookupQueryPath:(NSString *)_path {
  DOMQueryPathExpression *expr;
  
  if (_path == nil)
    return nil;
  
  expr = [DOMQueryPathExpression queryPathWithString:_path];
  
  return [expr evaluateWithNode:self];
}

@end /* DOMNode(QueryPath) */
