// $Id: DOMNode.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMNode_H__
#define __DOMNode_H__

#import <Foundation/NSObject.h>
#include <DOM/DOMProtocols.h>

@class NSMutableArray, NSData;
@class DOMDocument;

@interface DOMNode : NSObject < DOMNode >
{
}

@end

@interface DOMNode(Additions)

- (NSString *)nodeTypeString;
- (NSString *)xmlStringValue;
- (NSData *)xmlDataValue;
- (NSString *)textValue;

@end

@interface DOMNodeWithChildren : DOMNode
{
@private
  NSMutableArray *childNodes;
}
@end

@interface NSObject(DOMNodePrivate)

- (id)_domNodeBeforeNode:(id)_node;
- (id)_domNodeAfterNode:(id)_node;

- (void)_domNodeRegisterParentNode:(id)_parentNode;
- (void)_domNodeForgetParentNode:(id)_parentNode;

@end

NSString *DOMNodeName(id _node);
NSString *DOMNodeValue(id _node);

#endif /* __DOMNode_H__ */
