// $Id: DOMNodeIterator.m,v 1.2 2003/01/02 09:51:25 helge Exp $

#include <DOM/DOMNodeIterator.h>
#include <DOM/DOMNodeFilter.h>
#include <DOM/DOMNode.h>
#include "common.h"

@implementation DOMNodeIterator

- (id)initWithRootNode:(id)_rootNode
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter
  expandEntityReferences:(BOOL)_flag
{
  NSAssert(_rootNode, @"missing root-node !");

  if ((self = [super init])) {
    self->root       = [_rootNode retain];
    self->whatToShow = _whatToShow;
    self->filter     = [_filter retain];
    self->expandEntityReferences = _flag;

    self->lastNode    = nil;
    self->beforeFirst = YES;
    self->afterLast   = NO;
  }
  return self;
}

- (void)dealloc {
  [self->lastNode release];
  [self->root     release];
  [self->filter   release];
  [super dealloc];
}
                 
/* attributes */

- (id)root {
  return self->root;
}
- (unsigned long)whatToShow {
  return self->whatToShow;
}
- (id)filter {
  return self->filter;
}
- (BOOL)expandEntityReferences {
  return self->expandEntityReferences;
}

/* operations */

- (id)nextNode {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}
- (id)previousNode {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}

- (void)detach {
}

@end /* DOMNodeIterator */
