// $Id: DOMNodeWalker.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMNodeWalker_H__
#define __DOMNodeWalker_H__

#import <Foundation/NSObject.h>

@interface DOMNodeWalker : NSObject
{
  id   target;
  SEL  selector;
  id   ctx;
  
  BOOL isStopped;
  id   rootNode;
  id   currentParentNode;
  id   currentNode;
}

- (id)initWithTarget:(id)_target selector:(SEL)_selector context:(id)_ctx;

/* context */

- (id)context;
- (id)rootNode;
- (id)currentParentNode;
- (id)currentNode;

/* walking */

- (void)walkNode:(id)_node;
- (void)stopWalking;

@end

@interface DOMNodePreorderWalker : DOMNodeWalker
@end
@interface DOMNodePostorderWalker : DOMNodeWalker
@end

#endif /* __DOMNodeWalker_H__ */
