// $Id: DOMTreeWalker.h,v 1.1.1.1 2002/05/22 17:25:57 helge Exp $

#ifndef __DOMTreeWalker_H__
#define __DOMTreeWalker_H__

#import <Foundation/NSObject.h>

@class NSArray;

@interface DOMTreeWalker : NSObject
{
  id            root;
  unsigned long whatToShow;
  id            filter;
  BOOL          expandEntityReferences;
  id            currentNode;

  /* cache state */
  NSArray       *visibleChildren;
}

/* attributes */

- (id)root;
- (unsigned long)whatToShow;
- (id)filter;
- (BOOL)expandEntityReferences;

- (void)setCurrentNode:(id)_node;
- (id)currentNode;

/* operations */

- (id)parentNode;
- (id)firstChild;
- (id)lastChild;
- (id)previousSibling;
- (id)nextSibling;

- (id)previousNode;
- (id)nextNode;

@end

@interface DOMTreeWalker(PrivateCtors)
/* use DOMDocument(DocumentTraversal) for constructing DOMTreeWalker's ! */

- (id)initWithRootNode:(id)_rootNode
  whatToShow:(unsigned long)_whatToShow
  filter:(id)_filter
  expandEntityReferences:(BOOL)_flag;

@end

#endif /* __DOMTreeWalker_H__ */
