// $Id: SaxAttributeList.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxAttributeList_H__
#define __SaxAttributeList_H__

#import <Foundation/NSObject.h>

@class NSString, NSMutableArray;

/* deprecated in SAX 2.0beta */

@protocol SaxAttributeList

- (NSString *)nameAtIndex:(unsigned int)_idx;
- (NSString *)typeAtIndex:(unsigned int)_idx;
- (NSString *)valueAtIndex:(unsigned int)_idx;
- (NSString *)typeForName:(NSString *)_name;
- (NSString *)valueForName:(NSString *)_name;

- (unsigned int)count;

@end

@interface SaxAttributeList : NSObject < SaxAttributeList, NSCopying >
{
@private
  NSMutableArray *names;
  NSMutableArray *types;
  NSMutableArray *values;
}

- (id)init;
- (id)initWithAttributeList:(id<SaxAttributeList>)_attrList;

- (void)setAttributeList:(id<SaxAttributeList>)_attrList;
- (void)clear;

- (void)addAttribute:(NSString *)_name
  type:(NSString *)_type
  value:(NSString *)_value;
- (void)removeAttribute:(NSString *)_attr;

@end

#include <SaxObjC/SaxAttributes.h>

@interface SaxAttributeList(Compatibility)
- (id)initWithAttributes:(id<SaxAttributes>)_attrs;
@end

#endif /* __SaxAttributeList_H__ */
