// $Id: SaxAttributes.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxAttributes_H__
#define __SaxAttributes_H__

#import <Foundation/NSObject.h>

@class NSString, NSArray, NSMutableArray;

/*
  new in SAX 2.0beta, replaces the SaxAttributeList
*/

@protocol SaxAttributes

/* lookup indices */

- (unsigned int)indexOfRawName:(NSString *)_rawName;
- (unsigned int)indexOfName:(NSString *)_localPart uri:(NSString *)_uri;

/* lookup data by index */

- (NSString *)nameAtIndex:(unsigned int)_idx;
- (NSString *)rawNameAtIndex:(unsigned int)_idx;
- (NSString *)typeAtIndex:(unsigned int)_idx;
- (NSString *)uriAtIndex:(unsigned int)_idx;
- (NSString *)valueAtIndex:(unsigned int)_idx;

/* lookup data by name */

- (NSString *)typeForRawName:(NSString *)_rawName;
- (NSString *)typeForName:(NSString *)_localName uri:(NSString *)_uri;
- (NSString *)valueForRawName:(NSString *)_rawName;
- (NSString *)valueForName:(NSString *)_localName uri:(NSString *)_uri;

/* list size */

- (unsigned int)count;

@end

/* simple attributes implementation, should be improved */

@interface SaxAttributes : NSObject < SaxAttributes, NSCopying >
{
@private
  NSMutableArray *names;
  NSMutableArray *uris;
  NSMutableArray *rawNames;
  NSMutableArray *types;
  NSMutableArray *values;
}

- (id)initWithAttributes:(id<SaxAttributes>)_attrs;

- (void)addAttribute:(NSString *)_localName uri:(NSString  *)_uri
  rawName:(NSString *)_rawName
  type:(NSString *)_type
  value:(NSString *)_value;

- (void)clear;

@end

#include <SaxObjC/SaxAttributeList.h>

@interface SaxAttributes(Compatibility)
- (id)initWithAttributeList:(id<SaxAttributeList>)_attrList;
@end

#endif /* __SaxAttributes_H__ */
