// $Id: SaxContentHandler.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxContentHandler_H__
#define __SaxContentHandler_H__

#import <Foundation/NSString.h>
#include <SaxObjC/SaxAttributes.h>
#include <SaxObjC/SaxLocator.h>

@class NSString;

/*
  new in SAX 2.0beta, replaces SaxDocumentHandler
*/
  
@protocol SaxContentHandler

- (void)startDocument;
- (void)endDocument;

- (void)startPrefixMapping:(NSString *)_prefix uri:(NSString *)_uri;
- (void)endPrefixMapping:(NSString *)_prefix;

- (void)startElement:(NSString *)_localName
  namespace:(NSString *)_ns
  rawName:(NSString *)_rawName
  attributes:(id<SaxAttributes>)_attributes;
- (void)endElement:(NSString *)_localName
  namespace:(NSString *)_ns
  rawName:(NSString *)_rawName;

/* CDATA */

- (void)characters:(unichar *)_chars          length:(int)_len;
- (void)ignorableWhitespace:(unichar *)_chars length:(int)_len;

/* PIs */

- (void)processingInstruction:(NSString *)_pi data:(NSString *)_data;

/* positioning info */

- (void)setDocumentLocator:(id<NSObject,SaxLocator>)_locator;

/* entities */

- (void)skippedEntity:(NSString *)_entityName;

@end

#endif /* __SaxContentHandler_H__ */
