// $Id: SaxDocumentHandler.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxDocumentHandler_H__
#define __SaxDocumentHandler_H__

#import <Foundation/NSString.h>
#include <SaxObjC/SaxAttributeList.h>
#include <SaxObjC/SaxLocator.h>

/* deprecated in SAX 2.0beta (replaced by SaxXMLContentHandler) */

@protocol SaxDocumentHandler

- (void)startDocument;
- (void)endDocument;

- (void)startElement:(NSString *)_tagName
  attributes:(id<SaxAttributeList>)_attrs;
- (void)endElement:(NSString *)_tagName;

/* CDATA */

- (void)characters:(unichar *)_chars          length:(int)_len;
- (void)ignorableWhitespace:(unichar *)_chars length:(int)_len;

/* PIs */

- (void)processingInstruction:(NSString *)_pi data:(NSString *)_data;

/* positioning info */

- (void)setDocumentLocator:(id<NSObject,SaxLocator>)_locator;

@end

#endif /* __SaxDocumentHandler_H__ */
