// $Id: SaxHandlerBase.m,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include "SaxHandlerBase.h"
#include "SaxException.h"

@implementation SaxHandlerBase

/* SaxDocumentHandler */

- (void)startDocument {
}
- (void)endDocument {
}

- (void)startElement:(NSString *)_tagName
  attributes:(id<SaxAttributeList>)_attrs
{
}
- (void)endElement:(NSString *)_tagName {
}

- (void)characters:(unichar *)_chars length:(int)_len {
}
- (void)ignorableWhitespace:(unichar *)_chars length:(int)_len {
}

- (void)processingInstruction:(NSString *)_pi data:(NSString *)_data {
}

- (void)setDocumentLocator:(id<NSObject,SaxLocator>)_locator {
}

/* SaxDTDHandler */

- (void)notationDeclaration:(NSString *)_name
  publicId:(NSString *)_pubId
  systemId:(NSString *)_sysId
{
}

- (void)unparsedEntityDeclaration:(NSString *)_name
  publicId:(NSString *)_pubId
  systemId:(NSString *)_sysId
  notationName:(NSString *)_notName
{
}

/* SaxEntityResolver */

- (id)resolveEntityWithPublicId:(NSString *)_pubId systemId:(NSString *)_sysId {
  return nil;
}

/* SaxErrorHandler */

- (void)warning:(SaxParseException *)_exception {
}
- (void)error:(SaxParseException *)_exception {
}

- (void)fatalError:(SaxParseException *)_exception {
  [_exception raise];
}

@end /* SaxHandlerBase */
