// $Id: SaxLocator.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxLocator_H__
#define __SaxLocator_H__

#import <Foundation/NSObject.h>

@class NSString;

@protocol SaxLocator

- (int)columnNumber;
- (int)lineNumber;
- (NSString *)publicId;
- (NSString *)systemId;

@end

/* sample locator */

@interface SaxLocator : NSObject < SaxLocator, NSCopying >
{
@private
  int      column;
  int      line;
  NSString *pubId;
  NSString *sysId;
}

- (id)init;
- (id)initWithLocator:(id<SaxLocator>)_locator;

- (void)setColumnNumber:(int)_col;
- (int)columnNumber;
- (void)setLineNumber:(int)_line;
- (int)lineNumber;
- (void)setPublicId:(NSString *)_pubId;
- (NSString *)publicId;
- (void)setSystemId:(NSString *)_sysId;
- (NSString *)systemId;

@end

#endif /* __SaxLocator_H__ */
