// $Id: SaxLocator.m,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include "SaxLocator.h"
#include "common.h"

@implementation SaxLocator

- (id)init {
  return self;
}
- (id)initWithLocator:(id<SaxLocator>)_locator {
  if ((self = [self init])) {
    self->column = [_locator columnNumber];
    self->line   = [_locator lineNumber];
    self->pubId  = [[_locator publicId] copy];
    self->sysId  = [[_locator systemId] copy];
  }
  return self;
}

- (void)dealloc {
  [self->pubId release];
  [self->sysId release];
  [super dealloc];
}

- (void)setColumnNumber:(int)_col {
  self->column = _col;
}
- (int)columnNumber {
  return self->column;
}

- (void)setLineNumber:(int)_line {
  self->line = _line;
}
- (int)lineNumber {
  return self->line;
}

- (void)setPublicId:(NSString *)_pubId {
  id o = self->pubId;
  self->pubId = [_pubId copy];
  [o release];
}
- (NSString *)publicId {
  return self->pubId;
}

- (void)setSystemId:(NSString *)_sysId {
  id o = self->sysId;
  self->sysId = [_sysId copy];
  [o release];
}
- (NSString *)systemId {
  return self->sysId;
}

/* NSCopying */

- (id)copyWithZone:(NSZone *)_zone {
  return [[[self class] allocWithZone:_zone] initWithLocator:self];
}

@end /* SaxLocator */
