// $Id: SaxObjectDecoder.h,v 1.1 2002/10/14 08:13:07 helge Exp $

#ifndef __SaxObjC_SaxObjectDecoder_H__
#define __SaxObjC_SaxObjectDecoder_H__

#include <SaxObjC/SaxDefaultHandler.h>

/*
  This SAX handler takes a model dictionary and maps the SAX events
  to object construction commands.
  
  [to be done: further description of format and function]
*/

@class SaxObjectModel;

@interface SaxObjectDecoder : SaxDefaultHandler
{
  id<NSObject,SaxLocator> locator;
  id rootObject;
  id mapping;

  NSMutableArray *infoStack;
  NSMutableArray *mappingStack;
  NSMutableArray *objectStack;
}

- (id)initWithMappingModel:(SaxObjectModel *)_model;
- (id)initWithMappingAtPath:(NSString *)_path;
- (id)initWithMappingNamed:(NSString *)_name;

/* parse results */

- (id)rootObject;

/* cleanup */

- (void)reset;

@end

@interface NSObject(SaxObjectCoding)

- (id)initWithSaxDecoder:(SaxObjectDecoder *)_decoder;
- (id)awakeAfterUsingSaxDecoder:(SaxObjectDecoder *)_decoder;

@end

#endif /* __SaxObjC_SaxObjectDecoder_H__ */
