// $Id: SaxObjectModel.h,v 1.2 2002/10/23 09:20:01 helge Exp $

#ifndef __SaxObjC_SaxObjectModel_H__
#define __SaxObjC_SaxObjectModel_H__

#import <Foundation/NSObject.h>

@class NSDictionary, NSString, NSArray;
@class SaxTagModel;

@interface SaxObjectModel : NSObject
{
  NSDictionary *nsToModel;
}

+ (id)modelWithName:(NSString *)_name;
+ (id)modelWithContentsOfFile:(NSString *)_path;

- (id)initWithDictionary:(NSDictionary *)_dict;

/* queries */

- (SaxTagModel *)modelForTag:(NSString *)_localName namespace:(NSString *)_ns;

@end

@interface SaxNamespaceModel : NSObject
{
  NSDictionary *tagToModel;
}

/* queries */

- (SaxTagModel *)modelForTag:(NSString *)_localName;

@end

@interface SaxTagModel : NSObject
{
  NSString     *className;
  NSString     *key;
  NSString     *tagKey;       /* the key to store the tag name under */
  NSString     *namespaceKey; /* the key to store the namespace uri under */
  NSString     *parentKey;    /* the key to store the parent object under */
  NSString     *contentKey;   /* the key to store the cdata content under */
  NSArray      *toManyRelationshipKeys;
  NSDictionary *defaultValues;
  NSDictionary *tagToKey;
  NSDictionary *attrToKey;
}

/* accessors */

- (NSString *)className;
- (NSString *)key;
- (NSString *)tagKey;
- (NSString *)namespaceKey;
- (NSString *)parentKey;
- (NSString *)contentKey;
- (NSDictionary *)defaultValues;

- (NSString *)propertyKeyForChildTag:(NSString *)_tag;

- (BOOL)isToManyKey:(NSString *)_key;
- (NSArray *)toManyRelationshipKeys;

- (NSArray *)attributeKeys;
- (NSString *)propertyKeyForAttribute:(NSString *)_attr;

/* object operations */

- (void)addValue:(id)_val toPropertyWithKey:(NSString *)_key ofObject:(id)_obj;

@end

#endif /* __SaxObjC_SaxObjectModel_H__ */
