// $Id: SaxXMLFilter.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxXMLFilter_H__
#define __SaxXMLFilter_H__

#import <Foundation/NSObject.h>
#include <SaxObjC/SaxXMLReader.h>

/* new in SAX 2.0beta */

@protocol SaxXMLFilter < SaxXMLReader >

- (void)setParent:(id<NSObject,SaxXMLReader>)_parent;
- (id<NSObject,SaxXMLReader>)parent;

@end

#include "SaxEntityResolver.h"
#include "SaxDTDHandler.h"
#include "SaxContentHandler.h"
#include "SaxErrorHandler.h"

@interface SaxXMLFilter : NSObject
  < SaxXMLFilter,
    SaxEntityResolver, SaxDTDHandler, SaxContentHandler, SaxErrorHandler >
{
@private
  id<NSObject,SaxXMLReader>      parent;
  id<NSObject,SaxContentHandler> contentHandler;
  id<NSObject,SaxDTDHandler>     dtdHandler;
  id<NSObject,SaxErrorHandler>   errorHandler;
  id<NSObject,SaxEntityResolver> entityResolver;
}

- (id)initWithParent:(id<NSObject,SaxXMLReader>)_parent;

@end

#endif /* __SaxXMLFilter_H__ */
