// $Id: SaxXMLReaderFactory.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __SaxXMLReaderFactory_H__
#define __SaxXMLReaderFactory_H__

#import <Foundation/NSObject.h>
#include <SaxObjC/SaxXMLReader.h>

/*
  To get a reader for HTML files:
    reader = [factory createXMLReaderForMimeType:@"text/html"];

  for XML files:
    reader = [factory createXMLReaderForMimeType:@"text/xml"];
    
  a specific reader:
    reader = [factory createXMLReaderWithName:@"libxmlSAXDriver"];
*/

@class NSDictionary;
    
@interface SaxXMLReaderFactory : NSObject
{
  NSDictionary *nameToBundle;
  NSDictionary *mimeTypeToName;
}

+ (id)standardXMLReaderFactory;

- (id<NSObject,SaxXMLReader>)createXMLReader;
- (id<NSObject,SaxXMLReader>)createXMLReaderWithName:(NSString *)_name;
- (id<NSObject,SaxXMLReader>)createXMLReaderForMimeType:(NSString *)_mtype;

- (NSArray *)availableXMLReaders;

@end

#endif /* __SaxXMLReaderFactory_H__ */
