// $Id: NSArray+XmlRpcCoding.m,v 1.3 2002/07/01 10:04:17 helge Exp $

#include "XmlRpcMethodResponse.h"
#include "XmlRpcCoder.h"
#include "NSObject+XmlRpc.h"
#include "common.h"

@implementation NSEnumerator(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"array";
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
  NSMutableArray *objs;
  id obj;
  
  /* make a copy to keep the enum state */
  self = [self copy];
  
  objs = [[NSMutableArray alloc] initWithCapacity:16];
  
  while ((obj = [self nextObject]))
    [objs addObject:obj];
  
  [_coder encodeArray:objs];
  [objs release];
  [self release];
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  return [[_coder decodeArray] objectEnumerator];
}

@end /* NSEnumerator(XmlRpc) */

@implementation NSArray(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"array";
}
- (NSArray *)xmlRpcElementSignature {
  unsigned i, count;
  NSMutableArray *ma;
  
  if ((count = [self count]) == 0)
    return [NSArray array];
  
  ma = [NSMutableArray arrayWithCapacity:count];
  for (i = 0; i < count; i++)
    [ma addObject:[[self objectAtIndex:i] xmlRpcType]];
  return ma;
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
  [_coder encodeArray:self];
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  return [_coder decodeArray];
}

@end /* NSArray(XmlRpc) */

@implementation NSSet(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"array";
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
  [_coder encodeArray:[self allObjects]];
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  return [NSSet setWithArray:[_coder decodeArray]];
}

@end /* NSSet(XmlRpcCoding) */
