// $Id: NSDate+XmlRpcCoding.m,v 1.3 2003/01/07 11:09:43 helge Exp $

#include "XmlRpcMethodResponse.h"
#include "NSObject+XmlRpc.h"
#include "XmlRpcCoder.h"
#import <Foundation/NSCalendarDate.h>
#include "common.h"

@implementation NSDate(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"dateTime.iso8601";
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
  [_coder encodeDateTime:self];
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  return [_coder decodeDateTime];
}

@end /* NSDate(XmlRpcCoding) */

@implementation NSTimeZone(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"string";
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
#if NeXT_Foundation_LIBRARY || APPLE_Foundation_LIBRARY
  [_coder encodeString:[self name]];
#else
  [_coder encodeString:[self timeZoneName]];
#endif
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  return [NSTimeZone timeZoneWithName:[_coder decodeString]];
}

@end /* NSTimeZone(XmlRpcCoding) */
