// $Id: NSNotification+XmlRpcCoding.m,v 1.2 2002/07/01 10:04:18 helge Exp $

#include "XmlRpcMethodResponse.h"
#include "common.h"
#include "XmlRpcCoder.h"

@implementation NSNotification(XmlRpcCoding)

- (NSString *)xmlRpcType {
  return @"struct";
}

+ (id)decodeObjectWithXmlRpcCoder:(XmlRpcDecoder *)_coder {
  self = [NSNotification notificationWithName:
                           [_coder decodeStringForKey:@"name"]
                         object:[_coder decodeObjectForKey:@"object"]
                         userInfo:[_coder decodeStructForKey:@"userInfo"]];
  return self;
}

- (void)encodeWithXmlRpcCoder:(XmlRpcEncoder *)_coder {
  NSString *n;

#if APPLE_Foundation_LIBRARY || NeXT_Foundation_LIBRARY
  n = [self name];
#else
  n = [self notificationName];
#endif

  [_coder encodeString:n forKey:@"name"];
  [_coder encodeObject:[self object]           forKey:@"object"];
  [_coder encodeStruct:[self userInfo]         forKey:@"userInfo"];
}

@end /* NSNotification(XmlRpcCoding) */
