// $Id: XmlRpcMethodResponse.m,v 1.2 2002/07/03 08:39:03 helge Exp $

#include "XmlRpcMethodResponse.h"
#include "XmlRpcCoder.h"
#include "common.h"

@interface XmlRpcMethodResponse(PrivateMethodes)
- (NSString *)_encodeXmlRpcMethodResponse;
@end

@implementation XmlRpcMethodResponse

- (id)initWithXmlRpcString:(NSString *)_string {
  XmlRpcDecoder        *coder;
  XmlRpcMethodResponse *baseResponse;
  
  if ([_string length] == 0) {
    [self release];
    return nil;
  }

  coder        = [[XmlRpcDecoder alloc] initForReadingWithString:_string];
  baseResponse = [coder decodeMethodResponse];
  [coder release];

  if (baseResponse == nil) {
    [self release];
    return nil;
  }
  
  self = [self initWithResult:[baseResponse result]];
  
  return self;
}

- (id)initWithResult:(id)_result {
  if ((self = [super init])) {
    self->result = [_result retain];
  }
  return self;
}

- (void)dealloc {
  [self->result release];
  [super dealloc];
}

/* accessors */

- (void)setResult:(id)_result {
  [self->result autorelease];
  self->result = [_result retain];
}
- (id)result {
  return self->result;
}

- (NSString *)xmlRpcString {
  return [self _encodeXmlRpcMethodResponse];
}

/* description */

- (NSString *)description {
  NSMutableString *ms;
  
  ms = [NSMutableString stringWithCapacity:64];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (result)
    [ms appendFormat:@" %@", self->result];
  else
    [ms appendString:@" no result"];
  
  [ms appendString:@">"];
  return ms;
}

@end /* XmlRpcMethodResponse */

@implementation XmlRpcMethodResponse(PrivateMethodes)

- (NSString *)_encodeXmlRpcMethodResponse {
  XmlRpcEncoder   *encoder = nil;
  NSMutableString *str     = nil;

  str = [NSMutableString stringWithCapacity:512];

  encoder = [[XmlRpcEncoder alloc] initForWritingWithMutableString:str];
  [encoder encodeMethodResponse:self];
  [encoder release];

  return str;
}

@end /* XmlRpcMethodResponse(PrivateMethodes) */
