// $Id: XmlRpcRequestEncoder.m,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include "XmlRpcCoder.h"
#include "XmlRpcMethodCall.h"
#include "common.h"

@interface XmlRpcEncoder(PrivateMethodes)
- (void)_encodeObject:(id)_object;
- (void)_reset;
@end

@implementation XmlRpcRequestEncoder

- (void)encodeRootObject:(XmlRpcMethodCall *)_methodCall {
  NSEnumerator *paramEnum;
  id           param;

  if (_methodCall == nil) return;

  if (![_methodCall isKindOfClass:[XmlRpcMethodCall class]]) {
    NSLog(@"%s: Warning: rootObject MUST be a XmlRpcMethodCall\n "
          @"(rootObject=%@)",
          __PRETTY_FUNCTION__,
          _methodCall);
    return;
  }
  
  [self _reset];
  
  paramEnum = [[_methodCall parameters] objectEnumerator];
  
  [self->string appendString:@"<?xml version='1.0'?>\n"];
  [self->string appendString:@"<methodCall>\n"];

  [self->string appendString:@"<methodName>"];
  [self->string appendString:[_methodCall methodName]];
  [self->string appendString:@"</methodName>\n"];
  
  [self->string appendString:@"<params>\n"];
  
  while ((param = [paramEnum nextObject])) {
    [self->string appendString:@"<param>\n"];
    [self->string appendString:@"<value>\n"];

    [self _encodeObject:param];
    
    [self->string appendString:@"</value>\n"];
    [self->string appendString:@"</param>\n"];
  }

  [self->string appendString:@"</params>\n"];
  
  [self->string appendString:@"</methodCall>\n"];
}

@end /* XmlRpcRequestEncoder */
