// $Id: XmlRpcResponseDecoder.m,v 1.3 2002/07/02 14:10:07 bjoern Exp $

#include "XmlRpcCoder.h"
#include "XmlRpcSaxHandler.h"
#include <SaxObjC/SaxXMLReaderFactory.h>
#include "common.h"

@implementation XmlRpcResponseDecoder

static id saxResponseHandler = nil;
static id responseParser     = nil;

- (void)_ensureSaxAndParser {
  if (saxResponseHandler == nil) {
    if ((saxResponseHandler = [[XmlRpcSaxResponseHandler alloc] init])==nil) {
      NSLog(@"%s: did not find sax handler ...", __PRETTY_FUNCTION__);
      return;
    }
  }

  if (responseParser != nil) return;
  
  responseParser =
    [[SaxXMLReaderFactory standardXMLReaderFactory]
                          createXMLReaderForMimeType:@"text/xml"];
  
  if (responseParser == nil) {
    NSLog(@"%s: did not find an XML parser ...", __PRETTY_FUNCTION__);
    return;
  }
  
  responseParser = [responseParser retain];
  [responseParser setContentHandler:saxResponseHandler];
  [responseParser setDTDHandler:saxResponseHandler];
  [responseParser setErrorHandler:saxResponseHandler];
}

- (id)decodeRootObject {
  static Class ExceptionClass = Nil;
  id     result;
  
  [self _ensureSaxAndParser];

  if (ExceptionClass == Nil)
    ExceptionClass = [NSException class];
  
  [saxResponseHandler reset];

  [responseParser parseFromSource:self->string systemId:nil];
  
  result = [saxResponseHandler result];

  if ([result isKindOfClass:ExceptionClass]) {
    return result;
  }
  else { // => XmlRpcValue
    XmlRpcValue *val     = result;
    Class       objClass = Nil;
    id          obj;

    [self->value autorelease];
    self->value = [val retain];

    if ((objClass = NSClassFromString([val className])) != Nil) {
      obj = [objClass decodeObjectWithXmlRpcCoder:self];
      return obj;
    }
  }
  
  return nil;
}

@end /* XmlRpcResponseDecoder */
