// $Id: XmlRpcResponseEncoder.m,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include "XmlRpcCoder.h"
#include "common.h"

@interface XmlRpcEncoder(PrivateMethodes)
- (void)_encodeObject:(id)_object;
- (void)_reset;
@end

@implementation XmlRpcResponseEncoder

- (void)encodeRootObject:(id)_object {
  static Class ExceptionClass = Nil;

  if (ExceptionClass == Nil)
    ExceptionClass = [NSException class];

  [self _reset];
  
  [self->string appendString:@"<?xml version='1.0'?>\n"];
  [self->string appendString:@"<methodResponse>\n"];

  if ([_object isKindOfClass:ExceptionClass]) {
    [self->string appendString:@"<fault>\n"];
    [self->string appendString:@"<value>\n"];

    [self _encodeObject:_object];
    
    [self->string appendString:@"</value>\n"];
    [self->string appendString:@"</fault>\n"];
  }
  else {
    [self->string appendString:@"<params>\n"];
    [self->string appendString:@"<param>\n"];
    [self->string appendString:@"<value>\n"];

    [self _encodeObject:_object];
    
    [self->string appendString:@"</value>\n"];
    [self->string appendString:@"</param>\n"];
    [self->string appendString:@"</params>\n"];
  }

  [self->string appendString:@"</methodResponse>\n"];
}

@end /* XmlRpcResponseEncoder */
