// $Id: XmlRpcSaxHandler.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __XmlRpcSaxHandler_H__
#define __XmlRpcSaxHandler_H__

#include <SaxObjC/SaxDefaultHandler.h>

/*
  Mappings:
  
    <i4> or <int>      -> NSNumber
    <boolean>          -> NSNumber
    <double>           -> NSNumber
    <base64>           -> NSData
    <string>           -> NSString
    <dateTime.iso8601> -> NSCalendarDate
    <struct>           -> NSDictionary
    <array>            -> NSArray
*/

@class NSMutableArray, NSTimeZone, NSCalendarDate;
@class XmlRpcMethodCall, XmlRpcMethodResponse;

@interface XmlRpcSaxHandler : SaxDefaultHandler
{
  XmlRpcMethodCall     *call;
  XmlRpcMethodResponse *response;
  
  NSMutableArray *params;
  NSString       *methodName;
  
  BOOL           invalidCall;
  NSMutableArray *tagStack;
  
  NSMutableArray *valueStack;
  NSString       *className;
  
  NSMutableArray *memberNameStack;
  NSMutableArray *memberValueStack;

  NSTimeZone     *timeZone;
  NSCalendarDate *dateTime;
  NSMutableString *characters;
  
  unsigned valueNestingLevel;
  SEL      nextCharactersProcessor;
}

/* reusing sax handler */

- (void)reset;

/* result accessors */

- (XmlRpcMethodCall *)methodCall;
- (XmlRpcMethodResponse *)methodResponse;

@end

#endif /* __XmlRpcSaxHandler_H__ */
