// $Id: NSCalendarDate+ICal.h,v 1.1 2002/10/10 08:06:26 helge Exp $

#ifndef __ICal2_NSCalendarDate_ICal_H__
#define __ICal2_NSCalendarDate_ICal_H__

#import <Foundation/NSCalendarDate.h>
#include <ical.h>

@class NSTimeZone;

@interface NSCalendarDate(ICalValue)

- (id)initWithICalTime:(struct icaltimetype)_dt timeZone:(NSTimeZone *)_tz;
- (id)initWithICalTime:(struct icaltimetype)_dt;

- (id)initWithICalDate:(struct icaltimetype)_dt timeZone:(NSTimeZone *)_tz;
- (id)initWithICalDate:(struct icaltimetype)_dt;

- (NSTimeZone *)timeZoneFromICalTime:(struct icaltimetype *)_dt
  defaultTimeZone:(NSTimeZone *)_tz;

/* libical values */

- (id)initWithICalValueHandle:(icalvalue *)_handle;
- (id)initWithICalValueOfProperty:(icalproperty *)_prop;

/* durations */

- (NSCalendarDate *)dateByApplyingICalDuration:(struct icaldurationtype)_dur;

/* represention */

- (NSString *)icalStringWithTimeZone:(NSTimeZone *)_tz;
- (NSString *)icalString;

@end

#endif /* __ICal2_NSCalendarDate_ICal_H__ */
