// $Id: TableCallbacks.m,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include "TableCallbacks.h"
#include "common.h"

//#define NSNonOwnedCStringMapKeyCallBacks NSNonOwnedPointerMapKeyCallBacks

/* From Aho, Sethi & Ullman: Principles of compiler design. */
static unsigned __hashCString(void *table, const void *aString) {
  register const char* p = (char*)aString;
  register unsigned hash = 0, hash2;
  register int i, n;
  
  n = aString ? strlen(aString) : 0;
  for(i=0; i < n; i++) {
    hash <<= 4;
    hash += *p++;
    if((hash2 = hash & 0xf0000000))
      hash ^= (hash2 >> 24) ^ hash2;
  }
  return hash;
}

static BOOL __compareCString(void *table, 
                               const void *anObject1,
                               const void *anObject2)
{
  if (anObject1 == NULL && anObject2 == NULL) return YES;
  if (anObject1 == NULL || anObject2 == NULL) return NO;
  return strcmp((char*)anObject1, (char*)anObject2) == 0;
}

static void __retain(void *table, const void *anObject) {}
static void __release(void *table, void *anObject) {}

static NSString *__describe(void *table, const void *anObject) {
    return [NSString stringWithFormat:@"%p", anObject];
}

const NSMapTableKeyCallBacks libxmlNonOwnedCStringMapKeyCallBacks =  {
    (unsigned(*)(NSMapTable *, const void *))__hashCString,
    (BOOL(*)(NSMapTable *, const void *, const void *))__compareCString,
    (void (*)(NSMapTable *, const void *anObject))__retain,
    (void (*)(NSMapTable *, void *anObject))__release,
    (NSString *(*)(NSMapTable *, const void *))__describe,
    (const void *)NULL
};
