// $Id: libxmlHTMLSAXDriver.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#include <SaxObjC/SaxXMLReader.h>
#include <SaxObjC/SaxLexicalHandler.h>
#include <SaxObjC/SaxDeclHandler.h>

/*
  recognized properties:
    http://xml.org/sax/properties/declaration-handler
    http://xml.org/sax/properties/lexical-handler
    http://www.skyrix.com/sax/properties/html-namespace
*/

@class libxmlSAXLocator;

@interface libxmlHTMLSAXDriver : NSObject < SaxXMLReader >
{
  id<NSObject,SaxContentHandler> contentHandler;
  id<NSObject,SaxDTDHandler>     dtdHandler;
  id<NSObject,SaxErrorHandler>   errorHandler;
  id<NSObject,SaxEntityResolver> entityResolver;
  
  id<NSObject,SaxLexicalHandler> lexicalHandler;
  id<NSObject,SaxDeclHandler>    declHandler;
  
  NSString *namespaceURI;
  unsigned depth;
  BOOL     encodeEntities;
  libxmlSAXLocator *locator;
  
  /* libxml */
  void *doc;
  void *ctxt;
  SaxAttributes *attributes;
}

@end
