// $Id: libxmlSAXDriver.h,v 1.1.1.1 2002/05/22 17:25:58 helge Exp $

#ifndef __libxmlSAXDriver_H__
#define __libxmlSAXDriver_H__

#import <Foundation/NSObject.h>
#include <SaxObjC/SaxXMLReader.h>
#include <SaxObjC/SaxContentHandler.h>
#include <SaxObjC/SaxDTDHandler.h>
#include <SaxObjC/SaxErrorHandler.h>
#include <SaxObjC/SaxEntityResolver.h>
#include <SaxObjC/SaxLexicalHandler.h>
#include <SaxObjC/SaxLocator.h>
#include <SaxObjC/SaxDeclHandler.h>

@class NSMutableArray;
@class SaxAttributes;

@class libxmlSAXLocator;

@interface libxmlSAXDriver : NSObject < SaxXMLReader >
{
@private
  id<NSObject,SaxContentHandler> contentHandler;
  id<NSObject,SaxDTDHandler>     dtdHandler;
  id<NSObject,SaxErrorHandler>   errorHandler;
  id<NSObject,SaxEntityResolver> entityResolver;
  
  id<NSObject,SaxLexicalHandler> lexicalHandler;
  id<NSObject,SaxDeclHandler>    declHandler;
  
  void           *sax;    /* ptr to libxml sax structure */
  void           *ctxt;   /* libxml parser context */
  void           *entity; /* used during entity lookup */
  
  int            depth;
  NSMutableArray *nsStack;
  BOOL           fNamespaces;
  BOOL           fNamespacePrefixes;
  
  /* cache */
  libxmlSAXLocator *locator;
  SaxAttributes    *attrs;
}

@end

#endif /* __libxmlSAXDriver_H__ */
