// $Id: libxmlSAXLocator.m,v 1.2 2003/01/02 09:54:22 helge Exp $

#import "libxmlSAXLocator.h"
#include "common.h"

@implementation libxmlSAXLocator

- (id)initWithSaxLocator:(xmlSAXLocatorPtr)_loc parser:(id)_parser {
  if (_loc == NULL) {
    [self release];
    return nil;
  }
  self->parser = _parser;
  self->getPublicId     = _loc->getPublicId;
  self->getSystemId     = _loc->getSystemId;
  self->getLineNumber   = _loc->getLineNumber;
  self->getColumnNumber = _loc->getColumnNumber;
  return self;
}

- (void)clear {
  self->parser = nil;
}

/* accessors */

- (int)columnNumber {
  //return -1;
  NSAssert(self->ctx, @"missing locator ctx ..");
  return self->getColumnNumber ? self->getColumnNumber(self->ctx) : -1;
}
- (int)lineNumber {
  //return -1;
  NSAssert(self->ctx, @"missing locator ctx ..");
  return self->getLineNumber ? self->getLineNumber(self->ctx) : -1;
}

- (NSString *)publicId {
  const xmlChar *s;
  //return nil;
  s = self->getPublicId ? self->getPublicId(self->ctx) : NULL;
  return s ? [NSString stringWithCString:s] : nil;
}

- (NSString *)systemId {
  const xmlChar *s;
  //return nil;
  s = self->getSystemId ? self->getSystemId(self->ctx) : NULL;
  return s ? [NSString stringWithCString:s] : nil;
}

/* description */

- (NSString *)description {
  return [NSString stringWithFormat:@"<0x%08X[%@]: pub=%@ sys=%@ L%i C%i>",
                     self, NSStringFromClass([self class]),
                     [self publicId], [self systemId],
                     [self lineNumber], [self columnNumber]];
}

@end /* libxmlSaxLocator */
